From 8cbe3a3c867e38ad6fd65f9c08822a5ec3e41680 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Pavel=20B=C5=99ezina?= <pbrezina@redhat.com>
Date: Mon, 9 Feb 2015 12:02:33 +0100
Subject: [PATCH 5/8] IFP: add org.freedesktop.sssd.infopipe.Users.User

Resolves:
https://fedorahosted.org/sssd/ticket/2150
---
 Makefile.am                                        |   2 +
 src/responder/ifp/ifp_groups.c                     |  39 +++
 src/responder/ifp/ifp_groups.h                     |  37 +++
 src/responder/ifp/ifp_iface.c                      |  13 +
 src/responder/ifp/ifp_iface.xml                    |  14 +
 src/responder/ifp/ifp_iface_generated.c            |  95 +++++++
 src/responder/ifp/ifp_iface_generated.h            |  30 +++
 src/responder/ifp/ifp_users.c                      | 297 +++++++++++++++++++++
 src/responder/ifp/ifp_users.h                      |  39 +++
 .../ifp/org.freedesktop.sssd.infopipe.conf         |   1 +
 10 files changed, 567 insertions(+)
 create mode 100644 src/responder/ifp/ifp_groups.c
 create mode 100644 src/responder/ifp/ifp_groups.h

diff --git a/Makefile.am b/Makefile.am
index 99f4515b593e08f0e7c71f49b73cf5cec7b2f633..21fc288cb6fcbcc8d85305f911bfcdabde19bfe0 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -543,6 +543,7 @@ dist_noinst_HEADERS = \
     src/responder/ifp/ifp_domains.h \
     src/responder/ifp/ifp_components.h \
     src/responder/ifp/ifp_users.h \
+    src/responder/ifp/ifp_groups.h \
     src/sbus/sbus_client.h \
     src/sbus/sssd_dbus.h \
     src/sbus/sssd_dbus_meta.h \
@@ -1078,6 +1079,7 @@ sssd_ifp_SOURCES = \
     src/responder/ifp/ifp_domains.c \
     src/responder/ifp/ifp_components.c \
     src/responder/ifp/ifp_users.c \
+    src/responder/ifp/ifp_groups.c \
     $(SSSD_UTIL_OBJ) \
     $(SSSD_RESPONDER_OBJ)
 sssd_ifp_CFLAGS = \
diff --git a/src/responder/ifp/ifp_groups.c b/src/responder/ifp/ifp_groups.c
new file mode 100644
index 0000000000000000000000000000000000000000..533e6806df11f4b569fca0e7a78694c3cd576001
--- /dev/null
+++ b/src/responder/ifp/ifp_groups.c
@@ -0,0 +1,39 @@
+/*
+    Authors:
+        Pavel Březina <pbrezina@redhat.com>
+
+    Copyright (C) 2015 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <talloc.h>
+
+#include "db/sysdb.h"
+#include "responder/ifp/ifp_groups.h"
+
+char * ifp_groups_build_path_from_msg(TALLOC_CTX *mem_ctx,
+                                      struct sss_domain_info *domain,
+                                      struct ldb_message *msg)
+{
+    const char *gid;
+
+    gid = ldb_msg_find_attr_as_string(msg, SYSDB_GIDNUM, NULL);
+
+    if (gid == NULL) {
+        return NULL;
+    }
+
+    return sbus_opath_compose(mem_ctx, IFP_PATH_GROUPS, domain->name, gid);
+}
diff --git a/src/responder/ifp/ifp_groups.h b/src/responder/ifp/ifp_groups.h
new file mode 100644
index 0000000000000000000000000000000000000000..1bdaf3e0c21e5ca53d9839264f87b8d10d3afbf1
--- /dev/null
+++ b/src/responder/ifp/ifp_groups.h
@@ -0,0 +1,37 @@
+/*
+    Authors:
+        Pavel Březina <pbrezina@redhat.com>
+
+    Copyright (C) 2015 Red Hat
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 3 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef IFP_GROUPS_H_
+#define IFP_GROUPS_H_
+
+#include "responder/ifp/ifp_iface_generated.h"
+#include "responder/ifp/ifp_private.h"
+
+#define IFP_PATH_GROUPS "/org/freedesktop/sssd/infopipe/Groups"
+#define IFP_PATH_GROUPS_TREE IFP_PATH_GROUPS SBUS_SUBTREE_SUFFIX
+
+/* Utility functions */
+
+char * ifp_groups_build_path_from_msg(TALLOC_CTX *mem_ctx,
+                                      struct sss_domain_info *domain,
+                                      struct ldb_message *msg);
+
+
+#endif /* IFP_GROUPS_H_ */
diff --git a/src/responder/ifp/ifp_iface.c b/src/responder/ifp/ifp_iface.c
index 753bad1269fbecad12cc9e6fea5455cce23aeb8e..7b61bb4a9d3a220892012d372bb7b28f31951a8a 100644
--- a/src/responder/ifp/ifp_iface.c
+++ b/src/responder/ifp/ifp_iface.c
@@ -85,6 +85,18 @@ struct iface_ifp_users iface_ifp_users = {
     .ListByDomainAndName = ifp_users_list_by_domain_and_name
 };
 
+struct iface_ifp_users_user iface_ifp_users_user = {
+    { &iface_ifp_users_user_meta, 0 },
+    .UpdateGroupsList = ifp_users_user_update_groups_list,
+    .get_name = ifp_users_user_get_name,
+    .get_uidNumber = ifp_users_user_get_uid_number,
+    .get_gidNumber = ifp_users_user_get_gid_number,
+    .get_gecos = ifp_users_user_get_gecos,
+    .get_homeDirectory = ifp_users_user_get_home_directory,
+    .get_loginShell = ifp_users_user_get_login_shell,
+    .get_groups = ifp_users_user_get_groups
+};
+
 struct iface_map {
     const char *path;
     struct sbus_vtable *vtable;
@@ -95,6 +107,7 @@ static struct iface_map iface_map[] = {
     { IFP_PATH_DOMAINS_TREE, &iface_ifp_domains.vtable },
     { IFP_PATH_COMPONENTS_TREE, &iface_ifp_components.vtable },
     { IFP_PATH_USERS, &iface_ifp_users.vtable },
+    { IFP_PATH_USERS_TREE, &iface_ifp_users_user.vtable },
     { NULL, NULL },
 };
 
diff --git a/src/responder/ifp/ifp_iface.xml b/src/responder/ifp/ifp_iface.xml
index d0c835949f62c2bad44f24ae251f4a2a273a093d..dc9d8882a2533ba3d358f389ac355022314acbe3 100644
--- a/src/responder/ifp/ifp_iface.xml
+++ b/src/responder/ifp/ifp_iface.xml
@@ -125,4 +125,18 @@
             <arg name="result" type="ao" direction="out"/>
         </method>
     </interface>
+
+    <interface name="org.freedesktop.sssd.infopipe.Users.User">
+        <annotation name="org.freedesktop.DBus.GLib.CSymbol" value="iface_ifp_users_user"/>
+
+        <method name="UpdateGroupsList" />
+
+        <property name="name" type="s" access="read" />
+        <property name="uidNumber" type="u" access="read" />
+        <property name="gidNumber" type="u" access="read" />
+        <property name="gecos" type="s" access="read" />
+        <property name="homeDirectory" type="s" access="read" />
+        <property name="loginShell" type="s" access="read" />
+        <property name="groups" type="ao" access="read" />
+    </interface>
 </node>
diff --git a/src/responder/ifp/ifp_iface_generated.c b/src/responder/ifp/ifp_iface_generated.c
index 40a416bc4d45e0600af3767c53fdab4f532c9cd0..bdc0ac9e072ddab4f8f778bac973691c37a0c538 100644
--- a/src/responder/ifp/ifp_iface_generated.c
+++ b/src/responder/ifp/ifp_iface_generated.c
@@ -652,6 +652,101 @@ const struct sbus_interface_meta iface_ifp_users_meta = {
     sbus_invoke_get_all, /* GetAll invoker */
 };
 
+int iface_ifp_users_user_UpdateGroupsList_finish(struct sbus_request *req)
+{
+   return sbus_request_return_and_finish(req,
+                                         DBUS_TYPE_INVALID);
+}
+
+/* methods for org.freedesktop.sssd.infopipe.Users.User */
+const struct sbus_method_meta iface_ifp_users_user__methods[] = {
+    {
+        "UpdateGroupsList", /* name */
+        NULL, /* no in_args */
+        NULL, /* no out_args */
+        offsetof(struct iface_ifp_users_user, UpdateGroupsList),
+        NULL, /* no invoker */
+    },
+    { NULL, }
+};
+
+/* property info for org.freedesktop.sssd.infopipe.Users.User */
+const struct sbus_property_meta iface_ifp_users_user__properties[] = {
+    {
+        "name", /* name */
+        "s", /* type */
+        SBUS_PROPERTY_READABLE,
+        offsetof(struct iface_ifp_users_user, get_name),
+        sbus_invoke_get_s,
+        0, /* not writable */
+        NULL, /* no invoker */
+    },
+    {
+        "uidNumber", /* name */
+        "u", /* type */
+        SBUS_PROPERTY_READABLE,
+        offsetof(struct iface_ifp_users_user, get_uidNumber),
+        sbus_invoke_get_u,
+        0, /* not writable */
+        NULL, /* no invoker */
+    },
+    {
+        "gidNumber", /* name */
+        "u", /* type */
+        SBUS_PROPERTY_READABLE,
+        offsetof(struct iface_ifp_users_user, get_gidNumber),
+        sbus_invoke_get_u,
+        0, /* not writable */
+        NULL, /* no invoker */
+    },
+    {
+        "gecos", /* name */
+        "s", /* type */
+        SBUS_PROPERTY_READABLE,
+        offsetof(struct iface_ifp_users_user, get_gecos),
+        sbus_invoke_get_s,
+        0, /* not writable */
+        NULL, /* no invoker */
+    },
+    {
+        "homeDirectory", /* name */
+        "s", /* type */
+        SBUS_PROPERTY_READABLE,
+        offsetof(struct iface_ifp_users_user, get_homeDirectory),
+        sbus_invoke_get_s,
+        0, /* not writable */
+        NULL, /* no invoker */
+    },
+    {
+        "loginShell", /* name */
+        "s", /* type */
+        SBUS_PROPERTY_READABLE,
+        offsetof(struct iface_ifp_users_user, get_loginShell),
+        sbus_invoke_get_s,
+        0, /* not writable */
+        NULL, /* no invoker */
+    },
+    {
+        "groups", /* name */
+        "ao", /* type */
+        SBUS_PROPERTY_READABLE,
+        offsetof(struct iface_ifp_users_user, get_groups),
+        sbus_invoke_get_ao,
+        0, /* not writable */
+        NULL, /* no invoker */
+    },
+    { NULL, }
+};
+
+/* interface info for org.freedesktop.sssd.infopipe.Users.User */
+const struct sbus_interface_meta iface_ifp_users_user_meta = {
+    "org.freedesktop.sssd.infopipe.Users.User", /* name */
+    iface_ifp_users_user__methods,
+    NULL, /* no signals */
+    iface_ifp_users_user__properties,
+    sbus_invoke_get_all, /* GetAll invoker */
+};
+
 /* invokes a handler with a 'ssu' DBus signature */
 static int invoke_ssu_method(struct sbus_request *dbus_req, void *function_ptr)
 {
diff --git a/src/responder/ifp/ifp_iface_generated.h b/src/responder/ifp/ifp_iface_generated.h
index 83ac75b06d4c747cd3a8d45b8f04d08b80e179db..051fa54497708f99b089983652a6b211c5d67d59 100644
--- a/src/responder/ifp/ifp_iface_generated.h
+++ b/src/responder/ifp/ifp_iface_generated.h
@@ -61,6 +61,17 @@
 #define IFACE_IFP_USERS_LISTBYNAME "ListByName"
 #define IFACE_IFP_USERS_LISTBYDOMAINANDNAME "ListByDomainAndName"
 
+/* constants for org.freedesktop.sssd.infopipe.Users.User */
+#define IFACE_IFP_USERS_USER "org.freedesktop.sssd.infopipe.Users.User"
+#define IFACE_IFP_USERS_USER_UPDATEGROUPSLIST "UpdateGroupsList"
+#define IFACE_IFP_USERS_USER_NAME "name"
+#define IFACE_IFP_USERS_USER_UIDNUMBER "uidNumber"
+#define IFACE_IFP_USERS_USER_GIDNUMBER "gidNumber"
+#define IFACE_IFP_USERS_USER_GECOS "gecos"
+#define IFACE_IFP_USERS_USER_HOMEDIRECTORY "homeDirectory"
+#define IFACE_IFP_USERS_USER_LOGINSHELL "loginShell"
+#define IFACE_IFP_USERS_USER_GROUPS "groups"
+
 /* ------------------------------------------------------------------------
  * DBus handlers
  *
@@ -188,6 +199,22 @@ int iface_ifp_users_ListByName_finish(struct sbus_request *req, const char *arg_
 /* finish function for ListByDomainAndName */
 int iface_ifp_users_ListByDomainAndName_finish(struct sbus_request *req, const char *arg_result[], int len_result);
 
+/* vtable for org.freedesktop.sssd.infopipe.Users.User */
+struct iface_ifp_users_user {
+    struct sbus_vtable vtable; /* derive from sbus_vtable */
+    int (*UpdateGroupsList)(struct sbus_request *req, void *data);
+    void (*get_name)(struct sbus_request *, void *data, const char * *);
+    void (*get_uidNumber)(struct sbus_request *, void *data, uint32_t *);
+    void (*get_gidNumber)(struct sbus_request *, void *data, uint32_t *);
+    void (*get_gecos)(struct sbus_request *, void *data, const char * *);
+    void (*get_homeDirectory)(struct sbus_request *, void *data, const char * *);
+    void (*get_loginShell)(struct sbus_request *, void *data, const char * *);
+    void (*get_groups)(struct sbus_request *, void *data, const char * * *, int *);
+};
+
+/* finish function for UpdateGroupsList */
+int iface_ifp_users_user_UpdateGroupsList_finish(struct sbus_request *req);
+
 /* ------------------------------------------------------------------------
  * DBus Interface Metadata
  *
@@ -210,4 +237,7 @@ extern const struct sbus_interface_meta iface_ifp_domains_meta;
 /* interface info for org.freedesktop.sssd.infopipe.Users */
 extern const struct sbus_interface_meta iface_ifp_users_meta;
 
+/* interface info for org.freedesktop.sssd.infopipe.Users.User */
+extern const struct sbus_interface_meta iface_ifp_users_user_meta;
+
 #endif /* __IFP_IFACE_XML__ */
diff --git a/src/responder/ifp/ifp_users.c b/src/responder/ifp/ifp_users.c
index 9aec9291c8b4de55f8dfdba9f3b5f5ab36e64a45..39213035fc29f0a47015aabe17ac634cec793a24 100644
--- a/src/responder/ifp/ifp_users.c
+++ b/src/responder/ifp/ifp_users.c
@@ -24,10 +24,12 @@
 
 #include "db/sysdb.h"
 #include "util/util.h"
+#include "util/strtonum.h"
 #include "sbus/sssd_dbus_errors.h"
 #include "responder/common/responder.h"
 #include "responder/common/responder_cache_req.h"
 #include "responder/ifp/ifp_users.h"
+#include "responder/ifp/ifp_groups.h"
 
 char * ifp_users_build_path_from_msg(TALLOC_CTX *mem_ctx,
                                      struct sss_domain_info *domain,
@@ -44,6 +46,41 @@ char * ifp_users_build_path_from_msg(TALLOC_CTX *mem_ctx,
     return sbus_opath_compose(mem_ctx, IFP_PATH_USERS, domain->name, uid);
 }
 
+errno_t ifp_users_decompose_path(struct sss_domain_info *domains,
+                                 const char *path,
+                                 struct sss_domain_info **_domain,
+                                 uid_t *_uid)
+{
+    char **parts = NULL;
+    struct sss_domain_info *domain;
+    uid_t uid;
+    errno_t ret;
+
+    ret = sbus_opath_decompose_exact(NULL, path, IFP_PATH_USERS, 2, &parts);
+    if (ret != EOK) {
+        return ret;
+    }
+
+    domain = find_domain_by_name(domains, parts[0], false);
+    if (domain == NULL) {
+        ret = ERR_DOMAIN_NOT_FOUND;
+        goto done;
+    }
+
+    uid = strtouint32(parts[1], NULL, 10);
+    if (errno != 0) {
+        ret = errno;
+        goto done;
+    }
+
+    *_domain = domain;
+    *_uid = uid;
+
+done:
+    talloc_free(parts);
+    return ret;
+}
+
 static void ifp_users_find_by_name_done(struct tevent_req *req);
 
 int ifp_users_find_by_name(struct sbus_request *sbus_req,
@@ -192,3 +229,263 @@ int ifp_users_list_by_domain_and_name(struct sbus_request *sbus_req,
 {
     return EOK;
 }
+
+static errno_t
+ifp_users_user_get(struct sbus_request *sbus_req,
+                   void *data,
+                   uid_t *_uid,
+                   struct sss_domain_info **_domain,
+                   struct ldb_message **_user)
+{
+    struct ifp_ctx *ctx;
+    struct sss_domain_info *domain;
+    struct ldb_result *res;
+    uid_t uid;
+    errno_t ret;
+
+    ctx = talloc_get_type(data, struct ifp_ctx);
+    if (ctx == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Invalid pointer!\n");
+        return ERR_INTERNAL;
+    }
+
+    ret = ifp_users_decompose_path(ctx->rctx->domains, sbus_req->path,
+                                   &domain, &uid);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Unable to decompose object path"
+              "[%s] [%d]: %s\n", sbus_req->path, ret, sss_strerror(ret));
+        return ret;
+    }
+
+    if (_user != NULL) {
+        ret = sysdb_getpwuid_with_views(sbus_req, domain, uid, &res);
+        if (ret == EOK && res->count == 0) {
+            *_user = NULL;
+            ret = ENOENT;
+        }
+
+        if (ret != EOK) {
+            DEBUG(SSSDBG_CRIT_FAILURE, "Unable to lookup user %u@%s [%d]: %s\n",
+                  uid, domain->name, ret, sss_strerror(ret));
+        } else {
+            *_user = res->msgs[0];
+        }
+    }
+
+    if (ret == EOK || ret == ENOENT) {
+        if (_uid != NULL) {
+            *_uid = uid;
+        }
+
+        if (_domain != NULL) {
+            *_domain = domain;
+        }
+    }
+
+    return ret;
+}
+
+static void ifp_users_get_as_string(struct sbus_request *sbus_req,
+                                    void *data,
+                                    const char *attr,
+                                    const char **_out)
+{
+    struct ldb_message *msg;
+    errno_t ret;
+
+    ret = ifp_users_user_get(sbus_req, data, NULL, NULL, &msg);
+    if (ret != EOK) {
+        *_out = NULL;
+        return;
+    }
+
+    *_out = ldb_msg_find_attr_as_string(msg, attr, NULL);
+
+    return;
+}
+
+static void ifp_users_get_as_uint32(struct sbus_request *sbus_req,
+                                    void *data,
+                                    const char *attr,
+                                    uint32_t *_out)
+{
+    struct ldb_message *msg;
+    errno_t ret;
+
+    ret = ifp_users_user_get(sbus_req, data, NULL, NULL, &msg);
+    if (ret != EOK) {
+        *_out = 0;
+        return;
+    }
+
+    *_out = ldb_msg_find_attr_as_uint(msg, attr, 0);
+
+    return;
+}
+
+static void ifp_users_user_update_groups_list_done(struct tevent_req *req);
+
+int ifp_users_user_update_groups_list(struct sbus_request *sbus_req,
+                                      void *data)
+{
+    struct tevent_req *req;
+    struct ifp_ctx *ctx;
+    struct sss_domain_info *domain;
+    const char *username;
+    struct ldb_message *user;
+    errno_t ret;
+
+    ctx = talloc_get_type(data, struct ifp_ctx);
+    if (ctx == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Invalid pointer!\n");
+        return ERR_INTERNAL;
+    }
+
+    ret = ifp_users_user_get(sbus_req, data, NULL, &domain, &user);
+    if (ret != EOK) {
+        return ret;
+    }
+
+    username = ldb_msg_find_attr_as_string(user, SYSDB_NAME, NULL);
+    if (username == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "User name is empty!\n");
+        return ERR_INTERNAL;
+    }
+
+    req = cache_req_initgr_by_name_send(sbus_req, ctx->rctx->ev, ctx->rctx,
+                                        ctx->ncache, ctx->neg_timeout, 0,
+                                        domain->name, username);
+    if (req == NULL) {
+        return ENOMEM;
+    }
+
+    tevent_req_set_callback(req, ifp_users_user_update_groups_list_done,
+                            sbus_req);
+
+    return EOK;
+}
+
+static void ifp_users_user_update_groups_list_done(struct tevent_req *req)
+{
+    DBusError *error;
+    struct sbus_request *sbus_req;
+    errno_t ret;
+
+    sbus_req = tevent_req_callback_data(req, struct sbus_request);
+
+    ret = cache_req_initgr_by_name_recv(sbus_req, req, NULL, NULL, NULL);
+    talloc_zfree(req);
+    if (ret == ENOENT) {
+        error = sbus_error_new(sbus_req, SBUS_ERROR_NOT_FOUND,
+                               "User not found");
+        goto done;
+    } else if (ret != EOK) {
+        error = sbus_error_new(sbus_req, DBUS_ERROR_FAILED, "Failed to fetch "
+                               "user [%d]: %s\n", ret, sss_strerror(ret));
+        goto done;
+    }
+
+done:
+    if (ret != EOK) {
+        sbus_request_fail_and_finish(sbus_req, error);
+        return;
+    }
+
+    iface_ifp_users_user_UpdateGroupsList_finish(sbus_req);
+    return;
+}
+
+void ifp_users_user_get_name(struct sbus_request *sbus_req,
+                             void *data,
+                             const char **_out)
+{
+    ifp_users_get_as_string(sbus_req, data, SYSDB_NAME, _out);
+}
+
+void ifp_users_user_get_uid_number(struct sbus_request *sbus_req,
+                                   void *data,
+                                   uint32_t *_out)
+{
+    ifp_users_get_as_uint32(sbus_req, data, SYSDB_UIDNUM, _out);
+}
+
+void ifp_users_user_get_gid_number(struct sbus_request *sbus_req,
+                                   void *data,
+                                   uint32_t *_out)
+{
+    ifp_users_get_as_uint32(sbus_req, data, SYSDB_GIDNUM, _out);
+}
+
+void ifp_users_user_get_gecos(struct sbus_request *sbus_req,
+                              void *data,
+                              const char **_out)
+{
+    ifp_users_get_as_string(sbus_req, data, SYSDB_GECOS, _out);
+}
+
+void ifp_users_user_get_home_directory(struct sbus_request *sbus_req,
+                                       void *data,
+                                       const char **_out)
+{
+    ifp_users_get_as_string(sbus_req, data, SYSDB_HOMEDIR, _out);
+}
+
+void ifp_users_user_get_login_shell(struct sbus_request *sbus_req,
+                                    void *data,
+                                    const char **_out)
+{
+    ifp_users_get_as_string(sbus_req, data, SYSDB_SHELL, _out);
+}
+
+void ifp_users_user_get_groups(struct sbus_request *sbus_req,
+                               void *data,
+                               const char ***_out,
+                               int *_size)
+{
+    struct sss_domain_info *domain;
+    const char *username;
+    struct ldb_message *user;
+    struct ldb_result *res;
+    const char **out;
+    errno_t ret;
+    int i;
+
+    *_out = NULL;
+    *_size = 0;
+
+    ret = ifp_users_user_get(sbus_req, data, NULL, &domain, &user);
+    if (ret != EOK) {
+        return;
+    }
+
+    username = ldb_msg_find_attr_as_string(user, SYSDB_NAME, NULL);
+    if (username == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "User name is empty!\n");
+        return;
+    }
+
+    /* Run initgroups. */
+    ret = sysdb_initgroups_with_views(sbus_req, domain, username, &res);
+    if (ret != EOK) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "Unable to get groups for %s@%s [%d]: %s\n",
+              username, domain->name, ret, sss_strerror(ret));
+        return;
+    }
+
+    out = talloc_zero_array(sbus_req, const char *, res->count);
+    if (out == NULL) {
+        DEBUG(SSSDBG_CRIT_FAILURE, "talloc_zero_array() failed\n");
+        return;
+    }
+
+    for (i = 0; i < res->count; i++) {
+        out[i] = ifp_groups_build_path_from_msg(out, domain, res->msgs[i]);
+        if (out[i] == NULL) {
+            DEBUG(SSSDBG_CRIT_FAILURE, "ifp_groups_build_path() failed\n");
+            return;
+        }
+    }
+
+    *_out = out;
+    *_size = res->count;
+}
diff --git a/src/responder/ifp/ifp_users.h b/src/responder/ifp/ifp_users.h
index a0a079f482553e8b7b3fd874140cedfc29fdb7f8..fc68ade8880f0570bc87fe8e7bc534d201acf9ee 100644
--- a/src/responder/ifp/ifp_users.h
+++ b/src/responder/ifp/ifp_users.h
@@ -33,6 +33,11 @@ char * ifp_users_build_path_from_msg(TALLOC_CTX *mem_ctx,
                                      struct sss_domain_info *domain,
                                      struct ldb_message *msg);
 
+errno_t ifp_users_decompose_path(struct sss_domain_info *domains,
+                                 const char *path,
+                                 struct sss_domain_info **_domain,
+                                 uid_t *_uid);
+
 /* org.freedesktop.sssd.infopipe.Users */
 
 int ifp_users_find_by_name(struct sbus_request *sbus_req,
@@ -54,4 +59,38 @@ int ifp_users_list_by_domain_and_name(struct sbus_request *sbus_req,
                                       const char *filter,
                                       uint32_t limit);
 
+/* org.freedesktop.sssd.infopipe.Users.User */
+
+int ifp_users_user_update_groups_list(struct sbus_request *req,
+                                      void *data);
+
+void ifp_users_user_get_name(struct sbus_request *sbus_req,
+                             void *data,
+                             const char **_out);
+
+void ifp_users_user_get_uid_number(struct sbus_request *sbus_req,
+                                   void *data,
+                                   uint32_t *_out);
+
+void ifp_users_user_get_gid_number(struct sbus_request *sbus_req,
+                                   void *data,
+                                   uint32_t *_out);
+
+void ifp_users_user_get_gecos(struct sbus_request *sbus_req,
+                              void *data,
+                              const char **_out);
+
+void ifp_users_user_get_home_directory(struct sbus_request *sbus_req,
+                                       void *data,
+                                       const char **_out);
+
+void ifp_users_user_get_login_shell(struct sbus_request *sbus_req,
+                                    void *data,
+                                    const char **_out);
+
+void ifp_users_user_get_groups(struct sbus_request *sbus_req,
+                               void *data,
+                               const char ***_out,
+                               int *_size);
+
 #endif /* IFP_USERS_H_ */
diff --git a/src/responder/ifp/org.freedesktop.sssd.infopipe.conf b/src/responder/ifp/org.freedesktop.sssd.infopipe.conf
index 195e73aa9b00455af5732a079052cd49baae8624..79160bbcc2800cfb98dfa79dbf5e445f2e42a6e0 100644
--- a/src/responder/ifp/org.freedesktop.sssd.infopipe.conf
+++ b/src/responder/ifp/org.freedesktop.sssd.infopipe.conf
@@ -31,6 +31,7 @@
 
     <allow send_interface="org.freedesktop.sssd.infopipe"/>
     <allow send_interface="org.freedesktop.sssd.infopipe.Users"/>
+    <allow send_interface="org.freedesktop.sssd.infopipe.Users.User"/>
   </policy>
 
   <policy user="root">
-- 
2.1.0