--- fedora-security-guide_7_Zip_fr.po	2011-09-24 21:18:00.000000000 +0000
+++ fedora-security-guide_7_Zip_fr1.po	2011-09-26 19:58:23.000000000 +0000
@@ -1,23 +1,25 @@
-# AUTHOR <EMAIL@ADDRESS>, YEAR.
-# 
-# Translators:
+#
+# Translators: Antoine POUILLAUDE
+# AUTHOR <EMAIL@ADDRESS>, YEAR., 2011.
 msgid ""
 msgstr ""
 "Project-Id-Version: Fedora Security Guide\n"
 "POT-Creation-Date: 2011-09-13T03:19:22\n"
-"PO-Revision-Date: 2011-09-24 21:16+0000\n"
-"Last-Translator: Automatically generated\n"
+"PO-Revision-Date: 2011-09-26 19:56+0000\n"
+"Last-Translator: \n"
 "Language-Team: French <trans-fr@lists.fedoraproject.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Language: fr\n"
 "Plural-Forms: nplurals=2; plural=(n > 1)\n"
+"Report-Msgid-Bugs-To: https://bugzilla.redhat.com/\n"
+"X-Generator: Lokalize 1.2\n"
 
 #. Tag: title
 #, no-c-format
 msgid "7-Zip Encrypted Archives"
-msgstr ""
+msgstr "Archives cryptées 7-zip"
 
 #. Tag: para
 #, no-c-format
@@ -29,11 +31,20 @@
 msgid ""
 "<ulink url=\"http://www.7-zip.org/\">7-Zip</ulink> is a cross-platform, next"
 " generation, file compression tool that can also use strong encryption "
 "(AES-256) to protect the contents of the archive. This is extremely useful "
 "when you need to move data between multiple computers that use varying "
 "operating systems (i.e. Linux at home, Windows at work) and you want a "
 "portable encryption solution."
 msgstr ""
+"<ulink url=\"http://www.7-zip.org/\">7-Zip</ulink> est un outil de "
+"compression de fichiers"
+" de dernière génération capable aussi d'utiliser un cryptage (AES-256) "
+"puissant pour protéger le contenu de vos archives. Ceci est extrêmement utile "
+"lorsque vous avez besoin de déplacer des données entre de nombreux "
+"ordinateurs qui utilisent différents "
+"systèmes d'exploitations (i.e. Linux chez vous, Windows au travail) et "
+"lorsque vous voulez une "
+"solution de chiffrement portable."
 
 #. Tag: title
 #, no-c-format
 msgid "7-Zip Installation in Fedora"
-msgstr ""
+msgstr "Installation de 7-Zip dans Fedora"
 
 #. Tag: para
 #, no-c-format
@@ -42,11 +53,16 @@
 msgid ""
 "7-Zip is not a base package in Fedora, but it is available in the software "
 "repository. Once installed, the package will update alongside the rest of "
 "the software on the computer with no special attention necessary."
 msgstr ""
+"7-Zip n'est pas un paquet de base de Fedora, mais il est disponible dans le "
+"répertoire "
+"de logiciels. Une fois installé, le paquet se mettra à jour automatiquement "
+"en même temps que "
+"le reste du logiciel."
 
 #. Tag: title
 #, no-c-format
 msgid "Step-by-Step Installation Instructions"
-msgstr ""
+msgstr "Guide d'installation étape par étape"
 
 #. Tag: para
 #, no-c-format
@@ -54,21 +70,24 @@
 msgid ""
 "Open a Terminal: <code>Click ''Applications'' -&gt; ''System Tools'' -&gt; "
 "''Terminal''</code>"
 msgstr ""
+"Ouvrez un Terminal : <code>Click ''Applications'' -&gt; ''Outils Système'' "
+"-&gt; "
+"''Terminal''</code>"
 
 #. Tag: para
 #, no-c-format
 msgid "Install 7-Zip with sudo access: <code>sudo yum install p7zip</code>"
-msgstr ""
+msgstr "Installez 7-Zip en mode sudo : <code>sudo yum install p7zip</code>"
 
 #. Tag: para
 #, no-c-format
 msgid "Close the Terminal: <code>exit</code>"
-msgstr ""
+msgstr "Fermez le Terminal : <code>exit</code>"
 
 #. Tag: title
 #, no-c-format
 msgid "Step-by-Step Usage Instructions"
-msgstr ""
+msgstr "Guide d'utilisation étape par étape"
 
 #. Tag: para
 #, no-c-format
@@ -78,6 +97,10 @@
 msgid ""
 "By following these instructions you are going to compress and encrypt your "
 "\"Documents\" directory. Your original \"Documents\" directory will remain "
 "unaltered. This technique can be applied to any directory or file you have "
 "access to on the filesystem."
 msgstr ""
+"En suivant ces instructions vous allez compresser et crypter votre dossier "
+"« Documents ». Votre dossier « Documents » original ne sera pas altéré. Cette "
+"technique peut être appliquée sur tous les dossiers et fichiers auxquels vous "
+"avez accès dans le système de fichiers."
 
 #. Tag: para
 #, no-c-format
@@ -85,6 +108,9 @@
 msgid ""
 "Open a Terminal:<code>Click ''Applications'' -&gt; ''System Tools'' -&gt; "
 "''Terminal''</code>"
 msgstr ""
+"Ouvrez un Terminal : <code>Click ''Applications'' -&gt; ''Outils Système'' "
+"-&gt; "
+"''Terminal''</code>\""
 
 #. Tag: para
 #, no-c-format
@@ -92,6 +118,9 @@
 msgid ""
 "Compress and Encrypt: (enter a password when prompted) <code>7za a -mhe=on "
 "-ms=on -p Documents.7z Documents/</code>"
 msgstr ""
+"Compressez et chiffrez : (entrez un mot de passe lorsque vous y êtes invité) "
+"<code>7za a -mhe=on "
+"-ms=on -p Documents.7z Documents/</code>"
 
 #. Tag: para
 #, no-c-format
@@ -100,21 +129,23 @@
 msgid ""
 "The \"Documents\" directory is now compressed and encrypted. The following "
 "instructions will move the encrypted archive somewhere new and then extract "
 "it."
 msgstr ""
+"Le dossier « Documents » est à présent compressé et chiffré. Les instructions "
+"suivantes vont déplacer et extraire l'archive chiffrée dans un nouvel endroit."
 
 #. Tag: para
 #, no-c-format
 msgid "Create a new directory: <code>mkdir newplace</code>"
-msgstr ""
+msgstr "Créez un nouveau dossier : <code>mkdir newplace</code>"
 
 #. Tag: para
 #, no-c-format
 msgid "Move the encrypted file: <code>mv Documents.7z newplace</code>"
-msgstr ""
+msgstr "Déplacez le fichier chiffré : <code>mv Documents.7z newplace</code>"
 
 #. Tag: para
 #, no-c-format
 msgid "Go to the new directory: <code>cd newplace</code>"
-msgstr ""
+msgstr "Allez dans le nouveau dossier : <code>cd newplace</code>"
 
 #. Tag: para
 #, no-c-format
@@ -122,6 +153,9 @@
 msgid ""
 "Extract the file: (enter the password when prompted) <code>7za x "
 "Documents.7z</code>"
 msgstr ""
+"Extrayez le fichier : (entrez le mots de passe quand vous y êtes invité) <"
+"code>7za x "
+"Documents.7z</code>"
 
 #. Tag: para
 #, no-c-format
@@ -130,22 +164,25 @@
 msgid ""
 "The archive is now extracted into the new location. The following "
 "instructions will clean up all the prior steps and restore your computer to "
 "its previous state."
 msgstr ""
+"L'archive est maintenant extraite dans le nouveau dossier. Les instructions "
+"suivantes vont effacer les étapes précédentes et restaurer votre ordinateur "
+"à son état antérieur."
 
 #. Tag: para
 #, no-c-format
 msgid "Go up a directory: <code>cd ..</code>"
-msgstr ""
+msgstr "Remontez d'un répertoire : <code>cd ..</code>"
 
 #. Tag: para
 #, no-c-format
 msgid ""
 "Delete the test archive and test extraction: <code>rm -r newplace</code>"
-msgstr ""
+msgstr "Supprimez l'archive et l'extraction test : <code>rm -r newplace</code>"
 
 #. Tag: title
 #, no-c-format
 msgid "Things of note"
-msgstr ""
+msgstr "Notes"
 
 #. Tag: para
 #, no-c-format
@@ -155,5 +192,11 @@
 msgid ""
 "7-Zip is not shipped by default with Microsoft Windows or Mac OS X. If you "
 "need to use your 7-Zip files on those platforms you will need to install the"
 " appropriate version of 7-Zip on those computers. See the 7-Zip <ulink "
 "url=\"http://www.7-zip.org/download.html\">download page</ulink>."
 msgstr ""
+"7-Zip n'est pas livré par défaut avec Microsoft Windows ou Mac OS X. Si vous "
+"avez besoin d'utiliser votre fichier 7-Zip sur ces systèmes vous aurez à "
+"installer la version "
+"appropriée de 7-Zip sur ces ordinateurs. Allez sur la <ulink url=\"http://www."
+"7-zip.org/download.html\">"
+"page de téléchargement</ulink> de 7-Zip."
 
 